/' ============================================================================================ '/
/' FMOD Ex - Main C/C++ Network event system header file.                                       '/
/' Copyright (c), Firelight Technologies Pty, Ltd. 2004-2011.                                   '/
/'                                                                                              '/
/' This header is the base header for all other FMOD NetEventSystem headers. If you are         '/
/' programming in C use this exclusively, or if you are programming C++ use this in             '/
/' conjunction with FMOD_EVENT_NET.HPP                                                          '/
/' ============================================================================================ '/

#ifndef __FMOD_EVENT_NET_BI__
#define __FMOD_EVENT_NET_BI__
#inclib "fmod_event_net"

#ifndef __FMOD_EVENT_BI__
#include "fmod_event.bi"
#endif

/'
    FMOD NetEventSystem version number.  Check this against NetEventSystem_GetVersion.
    &Haaaabbcc -> aaaa = major version number.  bb = minor version number.  cc = development version number.
'/
#define FMOD_EVENT_NET_VERSION &H00044408

/'
    Default port that the target (game) will listen on
'/
#define FMOD_EVENT_NET_PORT    17997

#if Defined(__fb_win32__)
Extern "windows"
#else
Extern "c"
#endif

declare function FMOD_NetEventSystem_Init(byval eventsystem as FMOD_EVENTSYSTEM ptr, byval port as ushort) as FMOD_RESULT
declare function FMOD_NetEventSystem_Update() as FMOD_RESULT
declare function FMOD_NetEventSystem_Shutdown() as FMOD_RESULT
declare function FMOD_NetEventSystem_GetVersion (byval version as uinteger ptr) as FMOD_RESULT
end extern
#endif
